QGIS Application - Feature request #5396
Run algorithms in a different thread
2012-04-17 09:11 AM - Julien Malik

Status: Closed

Priority: High

Assignee: Victor Olaya

Category: Processing/Core

Pull Request or Patch supplied: Resolution: fixed/implemented
Easy fix?: No Copied to github as #: 15067
Description

Currently the module execution freezes the main GUI.
Execution of the modules should not be done on the main thread.

Related issues:
Duplicated by QGIS Application - Feature request # 11324: Let Processing wind... Closed 2014-10-04

History

#1 - 2012-04-22 03:19 PM - Camilo Polymeris

I'll have a look at this during the next days, if nobody else is working on it.

#2 - 2012-04-22 10:46 PM - Victor Olaya

Perfect!

There is a class named AlgorithmExecutor. That's where it should go. If you have questions, just ask me, ok?

#3 - 2012-05-04 11:21 AM - Camilo Polymeris

Was implementing this in the GUI code, but am not longer sure that is the right approach. Perhaps it should be lower level, so the functionality can be used

in other parts of the code?

#4 - 2012-05-04 01:37 PM - Victor Olaya

IT should go on the AlgorithmExecutor Class. All other classes call it when executing an algorithm. It is on the gui package because it is used by gui

elements, but we can move it later to another one. It is not itself a GUI class.

#5 - 2012-06-01 05:05 AM - Paolo Cavallini

- Assignee changed from Victor Olaya to Camilo Polymeris

#6 - 2012-06-04 02:59 PM - Camilo Polymeris

- File mt3.diff added

This weeks diff. Includes mostly GUI improvements (percentage, feedback and a close button) and some attempts at making the iteration code work. I'll
update the blog at sextante-gsoc.blogspot.com with more details, but here some technical considerations:
- Am getting crashes with the (working thread) iteration code, apparently accesses to QPixmap, but haven't been able to find the source of the problem.

- Using "new-style" PyQT slots and signals. Is that ok?
Note that the cancel button only disconnects the finished signal, since the backends don't support cancelling. One could just terminate them, but that might

be problematic (file access and such).

#7 - 2012-06-04 06:29 PM - Camilo Polymeris
- File mt4.diff added

Iteration should work with the attached patch.

#8 - 2014-10-04 12:08 PM - Giovanni Manghi
- Project changed from 78 to QGIS Application
- Category deleted (63)

#9 - 2014-10-04 12:09 PM - Giovanni Manghi
- Category set to Processing/Core

#10 - 2014-10-04 12:10 PM - Giovanni Manghi
- Assignee changed from Camilo Polymeris to Victor Olaya

#11 - 2014-10-05 01:40 AM - Paolo Cavallini

Possibly duplicated in #11324

#12 - 2015-06-07 02:33 AM - Giovanni Manghi

- Status changed from Open to In Progress

- Priority changed from Normal to High

- Target version set to Future Release - High Priority

work undergoing as google summer of code

http://www.google-melange.com/gsoc/project/details/google/gsoc2015/mvcs/5741031244955648

#13 - 2017-05-01 12:48 AM - Giovanni Manghi
- Easy fix? set to No

#14 - 2017-10-03 01:30 PM - Alexander Bruy
- Status changed from In Progress to Closed

- Description updated
- Resolution set to fixed/implemented

Fixed in master

Files
http://www.google-melange.com/gsoc/project/details/google/gsoc2015/mvcs/5741031244955648

mt3.diff 16.8 KB 2012-06-04 Camilo Polymeris
mt4.diff 16 KB 2012-06-04 Camilo Polymeris
